<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (142)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="websocket">WebSocket</h1>
    <p>
      The <code>WebSocket</code> protocol, described in the specification
      <a href="http://tools.ietf.org/html/rfc6455">RFC 6455</a> provides a way
      to exchange data between browser and server via a persistent connection.
      The data can be passed in both directions as “packets”, without breaking
      the connection and additional HTTP-requests.
    </p>
    <p>
      WebSocket is especially great for services that require continuous data
      exchange, e.g. online games, real-time trading systems and so on.
    </p>
    <h2 id="a-simple-example">A simple example</h2>
    <p>
      To open a websocket connection, we need to create
      <code>new WebSocket</code> using the special protocol <code>ws</code> in
      the url:
    </p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">let</span> socket <span class="op">=</span> <span class="kw">new</span> <span class="at">WebSocket</span>(<span class="st">&quot;*!*ws*/!*://javascript.info&quot;</span>)<span class="op">;</span></a></code></pre>
    </div>
    <p>
      There’s also encrypted <code>wss://</code> protocol. It’s like HTTPS for
      websockets.
    </p>
    <p>
      ``<code>smart header="Always prefer</code>wss://<code>" The</code>wss://`
      protocol is not only encrypted, but also more reliable.
    </p>
    <p>
      That’s because <code>ws://</code> data is not encrypted, visible for any
      intermediary. Old proxy servers do not know about WebSocket, they may see
      “strange” headers and abort the connection.
    </p>
    <p>
      On the other hand, <code>wss://</code> is WebSocket over TLS, (same as
      HTTPS is HTTP over TLS), the transport security layer encrypts the data at
      sender and decrypts at the receiver. So data packets are passed encrypted
      through proxies. They can’t see what’s inside and let them through.
    </p>
    <pre><code>
Once the socket is created, we should listen to events on it. There are totally 4 events:
- **`open`** -- connection established,
- **`message`** -- data received,
- **`error`** -- websocket error,
- **`close`** -- connection closed.

...And if we&#39;d like to send something, then `socket.send(data)` will do that.

Here&#39;s an example:

```js run
let socket = new WebSocket(&quot;wss://javascript.info/article/websocket/demo/hello&quot;);

socket.onopen = function(e) {
  alert(&quot;[open] Connection established&quot;);
  alert(&quot;Sending to server&quot;);
  socket.send(&quot;My name is John&quot;);
};

socket.onmessage = function(event) {
  alert(`[message] Data received from server: ${event.data}`);
};

socket.onclose = function(event) {
  if (event.wasClean) {
    alert(`[close] Connection closed cleanly, code=${event.code} reason=${event.reason}`);
  } else {
    // e.g. server process killed or network down
    // event.code is usually 1006 in this case
    alert(&#39;[close] Connection died&#39;);
  }
};

socket.onerror = function(error) {
  alert(`[error] ${error.message}`);
};</code></pre>
    <p>
      For demo purposes, there’s a small server
      <a href="demo/server.js">server.js</a> written in Node.js, for the example
      above, running. It responds with “Hello from server, John”, then waits 5
      seconds and closes the connection.
    </p>
    <p>
      So you’ll see events <code>open</code> -&gt; <code>message</code> -&gt;
      <code>close</code>.
    </p>
    <p>
      That’s actually it, we can talk WebSocket already. Quite simple, isn’t it?
    </p>
    <p>Now let’s talk more in-depth.</p>
    <h2 id="opening-a-websocket">Opening a websocket</h2>
    <p>
      When <code>new WebSocket(url)</code> is created, it starts connecting
      immediately.
    </p>
    <p>
      During the connection the browser (using headers) asks the server: “Do you
      support Websocket?” And if the server replies “yes”, then the talk
      continues in WebSocket protocol, which is not HTTP at all.
    </p>
    <p><img src="websocket-handshake.svg" /></p>
    <p>
      Here’s an example of browser headers for request made by
      <code>new WebSocket("wss://javascript.info/chat")</code>.
    </p>
    <pre><code>GET /chat
Host: javascript.info
Origin: https://javascript.info
Connection: Upgrade
Upgrade: websocket
Sec-WebSocket-Key: Iv8io/9s+lYFgZWcXczP8Q==
Sec-WebSocket-Version: 13</code></pre>
    <ul>
      <li>
        <code>Origin</code> – the origin of the client page,
        e.g. <code>https://javascript.info</code>. WebSocket objects are
        cross-origin by nature. There are no special headers or other
        limitations. Old servers are unable to handle WebSocket anyway, so there
        are no compatibility issues. But <code>Origin</code> header is
        important, as it allows the server to decide whether or not to talk
        WebSocket with this website.
      </li>
      <li>
        <code>Connection: Upgrade</code> – signals that the client would like to
        change the protocol.
      </li>
      <li>
        <code>Upgrade: websocket</code> – the requested protocol is “websocket”.
      </li>
      <li>
        <code>Sec-WebSocket-Key</code> – a random browser-generated key for
        security.
      </li>
      <li>
        <code>Sec-WebSocket-Version</code> – WebSocket protocol version, 13 is
        the current one.
      </li>
    </ul>
    <p>
      <code
        >smart header="WebSocket handshake can't be emulated" We can't use
        `XMLHttpRequest` or `fetch` to make this kind of HTTP-request, because
        JavaScript is not allowed to set these headers.</code
      >
    </p>
    <p>
      If the server agrees to switch to WebSocket, it should send code 101
      response:
    </p>
    <pre><code>101 Switching Protocols
Upgrade: websocket
Connection: Upgrade
Sec-WebSocket-Accept: hsBlbuDTkk24srzEOTBUlZAlC2g=</code></pre>
    <p>
      Here <code>Sec-WebSocket-Accept</code> is <code>Sec-WebSocket-Key</code>,
      recoded using a special algorithm. The browser uses it to make sure that
      the response corresponds to the request.
    </p>
    <p>
      Afterwards, the data is transfered using WebSocket protocol, we’ll see its
      structure (“frames”) soon. And that’s not HTTP at all.
    </p>
    <h3 id="extensions-and-subprotocols">Extensions and subprotocols</h3>
    <p>
      There may be additional headers <code>Sec-WebSocket-Extensions</code> and
      <code>Sec-WebSocket-Protocol</code> that describe extensions and
      subprotocols.
    </p>
    <p>For instance:</p>
    <ul>
      <li>
        <p>
          <code>Sec-WebSocket-Extensions: deflate-frame</code> means that the
          browser supports data compression. An extension is something related
          to transferring the data, functionality that extends WebSocket
          protocol. The header <code>Sec-WebSocket-Extensions</code> is sent
          automatically by the browser, with the list of all extensions it
          supports.
        </p>
      </li>
      <li>
        <p>
          <code>Sec-WebSocket-Protocol: soap, wamp</code> means that we’d like
          to transfer not just any data, but the data in
          <a href="http://en.wikipedia.org/wiki/SOAP">SOAP</a> or WAMP (“The
          WebSocket Application Messaging Protocol”) protocols. WebSocket
          subprotocols are registered in the
          <a href="http://www.iana.org/assignments/websocket/websocket.xml"
            >IANA catalogue</a
          >. So, this header describes data formats that we’re going to use.
        </p>
        <p>
          This optional header is set using the second parameter of
          <code>new WebSocket</code>. That’s the array of subprotocols, e.g. if
          we’d like to use SOAP or WAMP:
        </p>
        <div class="sourceCode" id="cb5">
          <pre
            class="sourceCode js"
          ><code class="sourceCode javascript"><a class="sourceLine" id="cb5-1" title="1"><span class="kw">let</span> socket <span class="op">=</span> <span class="kw">new</span> <span class="at">WebSocket</span>(<span class="st">&quot;wss://javascript.info/chat&quot;</span><span class="op">,</span> [<span class="st">&quot;soap&quot;</span><span class="op">,</span> <span class="st">&quot;wamp&quot;</span>])<span class="op">;</span></a></code></pre>
        </div>
      </li>
    </ul>
    <p>
      The server should respond with a list of protocols and extensions that it
      agrees to use.
    </p>
    <p>For example, the request:</p>
    <pre><code>GET /chat
Host: javascript.info
Upgrade: websocket
Connection: Upgrade
Origin: https://javascript.info
Sec-WebSocket-Key: Iv8io/9s+lYFgZWcXczP8Q==
Sec-WebSocket-Version: 13
*!*
Sec-WebSocket-Extensions: deflate-frame
Sec-WebSocket-Protocol: soap, wamp
*/!*</code></pre>
    <p>Response:</p>
    <pre><code>101 Switching Protocols
Upgrade: websocket
Connection: Upgrade
Sec-WebSocket-Accept: hsBlbuDTkk24srzEOTBUlZAlC2g=
*!*
Sec-WebSocket-Extensions: deflate-frame
Sec-WebSocket-Protocol: soap
*/!*</code></pre>
    <p>
      Here the server responds that it supports the extension “deflate-frame”,
      and only SOAP of the requested subprotocols.
    </p>
    <h2 id="data-transfer">Data transfer</h2>
    <p>
      WebSocket communication consists of “frames” – data fragments, that can be
      sent from either side, and can be of several kinds:
    </p>
    <ul>
      <li>
        “text frames” – contain text data that parties send to each other.
      </li>
      <li>
        “binary data frames” – contain binary data that parties send to each
        other.
      </li>
      <li>
        “ping/pong frames” are used to check the connection, sent from the
        server, the browser responds to these automatically.
      </li>
      <li>
        there’s also “connection close frame” and a few other service frames.
      </li>
    </ul>
    <p>In the browser, we directly work only with text or binary frames.</p>
    <p>
      <strong
        >WebSocket <code>.send()</code> method can send either text or binary
        data.</strong
      >
    </p>
    <p>
      A call <code>socket.send(body)</code> allows <code>body</code> in string
      or a binary format, including <code>Blob</code>, <code>ArrayBuffer</code>,
      etc. No settings required: just send it out in any format.
    </p>
    <p>
      <strong
        >When we receive the data, text always comes as string. And for binary
        data, we can choose between <code>Blob</code> and
        <code>ArrayBuffer</code> formats.</strong
      >
    </p>
    <p>
      That’s set by <code>socket.binaryType</code> property, it’s
      <code>"blob"</code> by default, so binary data comes as
      <code>Blob</code> objects.
    </p>
    <p>
      <a href="info:blob">Blob</a> is a high-level binary object, it directly
      integrates with <code>&lt;a&gt;</code>, <code>&lt;img&gt;</code> and other
      tags, so that’s a sane default. But for binary processing, to access
      individual data bytes, we can change it to <code>"arraybuffer"</code>:
    </p>
    <div class="sourceCode" id="cb8">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb8-1" title="1"><span class="va">socket</span>.<span class="at">binaryType</span> <span class="op">=</span> <span class="st">&quot;arraybuffer&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb8-2" title="2"><span class="va">socket</span>.<span class="at">onmessage</span> <span class="op">=</span> (event) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb8-3" title="3">  <span class="co">// event.data is either a string (if text) or arraybuffer (if binary)</span></a>
<a class="sourceLine" id="cb8-4" title="4"><span class="op">};</span></a></code></pre>
    </div>
    <h2 id="rate-limiting">Rate limiting</h2>
    <p>
      Imagine, our app is generating a lot of data to send. But the user has a
      slow network connection, maybe on a mobile internet, outside of a city.
    </p>
    <p>
      We can call <code>socket.send(data)</code> again and again. But the data
      will be buffered (stored) in memory and sent out only as fast as network
      speed allows.
    </p>
    <p>
      The <code>socket.bufferedAmount</code> property stores how many bytes
      remain buffered at this moment, waiting to be sent over the network.
    </p>
    <p>
      We can examine it to see whether the socket is actually available for
      transmission.
    </p>
    <div class="sourceCode" id="cb9">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb9-1" title="1"><span class="co">// every 100ms examine the socket and send more data</span></a>
<a class="sourceLine" id="cb9-2" title="2"><span class="co">// only if all the existing data was sent out</span></a>
<a class="sourceLine" id="cb9-3" title="3"><span class="at">setInterval</span>(() <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb9-4" title="4">  <span class="cf">if</span> (<span class="va">socket</span>.<span class="at">bufferedAmount</span> <span class="op">==</span> <span class="dv">0</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb9-5" title="5">    <span class="va">socket</span>.<span class="at">send</span>(<span class="at">moreData</span>())<span class="op">;</span></a>
<a class="sourceLine" id="cb9-6" title="6">  <span class="op">}</span></a>
<a class="sourceLine" id="cb9-7" title="7"><span class="op">},</span> <span class="dv">100</span>)<span class="op">;</span></a></code></pre>
    </div>
    <h2 id="connection-close">Connection close</h2>
    <p>
      Normally, when a party wants to close the connection (both browser and
      server have equal rights), they send a “connection close frame” with a
      numeric code and a textual reason.
    </p>
    <p>The method for that is:</p>
    <div class="sourceCode" id="cb10">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb10-1" title="1"><span class="va">socket</span>.<span class="at">close</span>([code]<span class="op">,</span> [reason])<span class="op">;</span></a></code></pre>
    </div>
    <ul>
      <li><code>code</code> is a special WebSocket closing code (optional)</li>
      <li>
        <code>reason</code> is a string that describes the reason of closing
        (optional)
      </li>
    </ul>
    <p>
      Then the other party in <code>close</code> event handler gets the code and
      the reason, e.g.:
    </p>
    <div class="sourceCode" id="cb11">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb11-1" title="1"><span class="co">// closing party:</span></a>
<a class="sourceLine" id="cb11-2" title="2"><span class="va">socket</span>.<span class="at">close</span>(<span class="dv">1000</span><span class="op">,</span> <span class="st">&quot;Work complete&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb11-3" title="3"></a>
<a class="sourceLine" id="cb11-4" title="4"><span class="co">// the other party</span></a>
<a class="sourceLine" id="cb11-5" title="5"><span class="va">socket</span>.<span class="at">onclose</span> <span class="op">=</span> (event) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb11-6" title="6">  <span class="co">// event.code === 1000</span></a>
<a class="sourceLine" id="cb11-7" title="7">  <span class="co">// event.reason === &quot;Work complete&quot;</span></a>
<a class="sourceLine" id="cb11-8" title="8">  <span class="co">// event.wasClean === true (clean close)</span></a>
<a class="sourceLine" id="cb11-9" title="9"><span class="op">};</span></a></code></pre>
    </div>
    <p>Most common code values:</p>
    <ul>
      <li>
        <code>1000</code> – the default, normal closure (used if no
        <code>code</code> supplied),
      </li>
      <li>
        <code>1006</code> – no way to set such code manually, indicates that the
        connection was lost (no close frame).
      </li>
    </ul>
    <p>There are other codes like:</p>
    <ul>
      <li>
        <code>1001</code> – the party is going away, e.g. server is shutting
        down, or a browser leaves the page,
      </li>
      <li><code>1009</code> – the message is too big to process,</li>
      <li><code>1011</code> – unexpected error on server,</li>
      <li>…and so on.</li>
    </ul>
    <p>
      The full list can be found in
      <a href="https://tools.ietf.org/html/rfc6455#section-7.4.1"
        >RFC6455, §7.4.1</a
      >.
    </p>
    <p>
      WebSocket codes are somewhat like HTTP codes, but different. In
      particular, any codes less than <code>1000</code> are reserved, there’ll
      be an error if we try to set such a code.
    </p>
    <div class="sourceCode" id="cb12">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb12-1" title="1"><span class="co">// in case connection is broken</span></a>
<a class="sourceLine" id="cb12-2" title="2"><span class="va">socket</span>.<span class="at">onclose</span> <span class="op">=</span> (event) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb12-3" title="3">  <span class="co">// event.code === 1006</span></a>
<a class="sourceLine" id="cb12-4" title="4">  <span class="co">// event.reason === &quot;&quot;</span></a>
<a class="sourceLine" id="cb12-5" title="5">  <span class="co">// event.wasClean === false (no closing frame)</span></a>
<a class="sourceLine" id="cb12-6" title="6"><span class="op">};</span></a></code></pre>
    </div>
    <h2 id="connection-state">Connection state</h2>
    <p>
      To get connection state, additionally there’s
      <code>socket.readyState</code> property with values:
    </p>
    <ul>
      <li>
        <strong><code>0</code></strong> – “CONNECTING”: the connection has not
        yet been established,
      </li>
      <li>
        <strong><code>1</code></strong> – “OPEN”: communicating,
      </li>
      <li>
        <strong><code>2</code></strong> – “CLOSING”: the connection is closing,
      </li>
      <li>
        <strong><code>3</code></strong> – “CLOSED”: the connection is closed.
      </li>
    </ul>
    <h2 id="chat-example">Chat example</h2>
    <p>
      Let’s review a chat example using browser WebSocket API and Node.js
      WebSocket module
      <a href="https://github.com/websockets/ws" class="uri"
        >https://github.com/websockets/ws</a
      >. We’ll pay the main attention to the client side, but the server is also
      simple.
    </p>
    <p>
      HTML: we need a <code>&lt;form&gt;</code> to send messages and a
      <code>&lt;div&gt;</code> for incoming messages:
    </p>
    <div class="sourceCode" id="cb13">
      <pre
        class="sourceCode html"
      ><code class="sourceCode html"><a class="sourceLine" id="cb13-1" title="1"><span class="co">&lt;!-- message form --&gt;</span></a>
<a class="sourceLine" id="cb13-2" title="2"><span class="kw">&lt;form</span><span class="ot"> name=</span><span class="st">&quot;publish&quot;</span><span class="kw">&gt;</span></a>
<a class="sourceLine" id="cb13-3" title="3">  <span class="kw">&lt;input</span><span class="ot"> type=</span><span class="st">&quot;text&quot;</span><span class="ot"> name=</span><span class="st">&quot;message&quot;</span> <span class="kw">/&gt;</span></a>
<a class="sourceLine" id="cb13-4" title="4">  <span class="kw">&lt;input</span><span class="ot"> type=</span><span class="st">&quot;submit&quot;</span><span class="ot"> value=</span><span class="st">&quot;Send&quot;</span> <span class="kw">/&gt;</span></a>
<a class="sourceLine" id="cb13-5" title="5"><span class="kw">&lt;/form&gt;</span></a>
<a class="sourceLine" id="cb13-6" title="6"></a>
<a class="sourceLine" id="cb13-7" title="7"><span class="co">&lt;!-- div with messages --&gt;</span></a>
<a class="sourceLine" id="cb13-8" title="8"><span class="kw">&lt;div</span><span class="ot"> id=</span><span class="st">&quot;messages&quot;</span><span class="kw">&gt;&lt;/div&gt;</span></a></code></pre>
    </div>
    <p>From JavaScript we want three things:</p>
    <ol type="1">
      <li>Open the connection.</li>
      <li>
        On form submission – <code>socket.send(message)</code> for the message.
      </li>
      <li>On incoming message – append it to <code>div#messages</code>.</li>
    </ol>
    <p>Here’s the code:</p>
    <div class="sourceCode" id="cb14">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb14-1" title="1"><span class="kw">let</span> socket <span class="op">=</span> <span class="kw">new</span> <span class="at">WebSocket</span>(<span class="st">&quot;wss://javascript.info/article/websocket/chat/ws&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb14-2" title="2"></a>
<a class="sourceLine" id="cb14-3" title="3"><span class="co">// send message from the form</span></a>
<a class="sourceLine" id="cb14-4" title="4"><span class="va">document</span>.<span class="va">forms</span>.<span class="va">publish</span>.<span class="at">onsubmit</span> <span class="op">=</span> <span class="kw">function</span> () <span class="op">{</span></a>
<a class="sourceLine" id="cb14-5" title="5">  <span class="kw">let</span> outgoingMessage <span class="op">=</span> <span class="kw">this</span>.<span class="va">message</span>.<span class="at">value</span><span class="op">;</span></a>
<a class="sourceLine" id="cb14-6" title="6"></a>
<a class="sourceLine" id="cb14-7" title="7">  <span class="va">socket</span>.<span class="at">send</span>(outgoingMessage)<span class="op">;</span></a>
<a class="sourceLine" id="cb14-8" title="8">  <span class="cf">return</span> <span class="kw">false</span><span class="op">;</span></a>
<a class="sourceLine" id="cb14-9" title="9"><span class="op">};</span></a>
<a class="sourceLine" id="cb14-10" title="10"></a>
<a class="sourceLine" id="cb14-11" title="11"><span class="co">// message received - show the message in div#messages</span></a>
<a class="sourceLine" id="cb14-12" title="12"><span class="va">socket</span>.<span class="at">onmessage</span> <span class="op">=</span> <span class="kw">function</span> (event) <span class="op">{</span></a>
<a class="sourceLine" id="cb14-13" title="13">  <span class="kw">let</span> message <span class="op">=</span> <span class="va">event</span>.<span class="at">data</span><span class="op">;</span></a>
<a class="sourceLine" id="cb14-14" title="14"></a>
<a class="sourceLine" id="cb14-15" title="15">  <span class="kw">let</span> messageElem <span class="op">=</span> <span class="va">document</span>.<span class="at">createElement</span>(<span class="st">&quot;div&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb14-16" title="16">  <span class="va">messageElem</span>.<span class="at">textContent</span> <span class="op">=</span> message<span class="op">;</span></a>
<a class="sourceLine" id="cb14-17" title="17">  <span class="va">document</span>.<span class="at">getElementById</span>(<span class="st">&quot;messages&quot;</span>).<span class="at">prepend</span>(messageElem)<span class="op">;</span></a>
<a class="sourceLine" id="cb14-18" title="18"><span class="op">};</span></a></code></pre>
    </div>
    <p>
      Server-side code is a little bit beyond our scope. Here we’ll use Node.js,
      but you don’t have to. Other platforms also have their means to work with
      WebSocket.
    </p>
    <p>The server-side algorithm will be:</p>
    <ol type="1">
      <li>Create <code>clients = new Set()</code> – a set of sockets.</li>
      <li>
        For each accepted websocket, add it to the set
        <code>clients.add(socket)</code> and setup <code>message</code> event
        listener to get its messages.
      </li>
      <li>
        When a message received: iterate over clients and send it to everyone.
      </li>
      <li>When a connection is closed: <code>clients.delete(socket)</code>.</li>
    </ol>
    <div class="sourceCode" id="cb15">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb15-1" title="1"><span class="kw">const</span> ws <span class="op">=</span> <span class="kw">new</span> <span class="at">require</span>(<span class="st">&quot;ws&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb15-2" title="2"><span class="kw">const</span> wss <span class="op">=</span> <span class="kw">new</span> <span class="va">ws</span>.<span class="at">Server</span>(<span class="op">{</span> <span class="dt">noServer</span><span class="op">:</span> <span class="kw">true</span> <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb15-3" title="3"></a>
<a class="sourceLine" id="cb15-4" title="4"><span class="kw">const</span> clients <span class="op">=</span> <span class="kw">new</span> <span class="at">Set</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb15-5" title="5"></a>
<a class="sourceLine" id="cb15-6" title="6"><span class="va">http</span>.<span class="at">createServer</span>((req<span class="op">,</span> res) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb15-7" title="7">  <span class="co">// here we only handle websocket connections</span></a>
<a class="sourceLine" id="cb15-8" title="8">  <span class="co">// in real project we&#39;d have some other code here to handle non-websocket requests</span></a>
<a class="sourceLine" id="cb15-9" title="9">  <span class="va">wss</span>.<span class="at">handleUpgrade</span>(req<span class="op">,</span> <span class="va">req</span>.<span class="at">socket</span><span class="op">,</span> <span class="va">Buffer</span>.<span class="at">alloc</span>(<span class="dv">0</span>)<span class="op">,</span> onSocketConnect)<span class="op">;</span></a>
<a class="sourceLine" id="cb15-10" title="10"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb15-11" title="11"></a>
<a class="sourceLine" id="cb15-12" title="12"><span class="kw">function</span> <span class="at">onSocketConnect</span>(ws) <span class="op">{</span></a>
<a class="sourceLine" id="cb15-13" title="13">  <span class="va">clients</span>.<span class="at">add</span>(ws)<span class="op">;</span></a>
<a class="sourceLine" id="cb15-14" title="14"></a>
<a class="sourceLine" id="cb15-15" title="15">  <span class="va">ws</span>.<span class="at">on</span>(<span class="st">&quot;message&quot;</span><span class="op">,</span> <span class="kw">function</span> (message) <span class="op">{</span></a>
<a class="sourceLine" id="cb15-16" title="16">    message <span class="op">=</span> <span class="va">message</span>.<span class="at">slice</span>(<span class="dv">0</span><span class="op">,</span> <span class="dv">50</span>)<span class="op">;</span> <span class="co">// max message length will be 50</span></a>
<a class="sourceLine" id="cb15-17" title="17"></a>
<a class="sourceLine" id="cb15-18" title="18">    <span class="cf">for</span> (<span class="kw">let</span> client <span class="kw">of</span> clients) <span class="op">{</span></a>
<a class="sourceLine" id="cb15-19" title="19">      <span class="va">client</span>.<span class="at">send</span>(message)<span class="op">;</span></a>
<a class="sourceLine" id="cb15-20" title="20">    <span class="op">}</span></a>
<a class="sourceLine" id="cb15-21" title="21">  <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb15-22" title="22"></a>
<a class="sourceLine" id="cb15-23" title="23">  <span class="va">ws</span>.<span class="at">on</span>(<span class="st">&quot;close&quot;</span><span class="op">,</span> <span class="kw">function</span> () <span class="op">{</span></a>
<a class="sourceLine" id="cb15-24" title="24">    <span class="va">clients</span>.<span class="at">delete</span>(ws)<span class="op">;</span></a>
<a class="sourceLine" id="cb15-25" title="25">  <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb15-26" title="26"><span class="op">}</span></a></code></pre>
    </div>
    <p>Here’s the working example:</p>
    <p>[iframe src=“chat” height=“100” zip]</p>
    <p>
      You can also download it (upper-right button in the iframe) and run
      locally. Just don’t forget to install
      <a href="https://nodejs.org/en/">Node.js</a> and
      <code>npm install ws</code> before running.
    </p>
    <h2 id="summary">Summary</h2>
    <p>
      WebSocket is a modern way to have persistent browser-server connections.
    </p>
    <ul>
      <li>WebSockets don’t have cross-origin limitations.</li>
      <li>They are well-supported in browsers.</li>
      <li>Can send/receive strings and binary data.</li>
    </ul>
    <p>The API is simple.</p>
    <p>Methods:</p>
    <ul>
      <li><code>socket.send(data)</code>,</li>
      <li><code>socket.close([code], [reason])</code>.</li>
    </ul>
    <p>Events:</p>
    <ul>
      <li><code>open</code>,</li>
      <li><code>message</code>,</li>
      <li><code>error</code>,</li>
      <li><code>close</code>.</li>
    </ul>
    <p>
      WebSocket by itself does not include reconnection, authentication and many
      other high-level mechanisms. So there are client/server libraries for
      that, and it’s also possible to implement these capabilities manually.
    </p>
    <p>
      Sometimes, to integrate WebSocket into existing project, people run
      WebSocket server in parallel with the main HTTP-server, and they share a
      single database. Requests to WebSocket use <code>wss://ws.site.com</code>,
      a subdomain that leads to WebSocket server, while
      <code>https://site.com</code> goes to the main HTTP-server.
    </p>
    <p>Surely, other ways of integration are also possible.</p>
  </body>
</html>
